unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    Image1: TImage;
    LabeledEdit2: TLabeledEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure clear;
    procedure Linetod(x, y: double);
    procedure Movetod(x, y: double);
    procedure anglline(q, r: double);
    procedure mnoe;
    procedure large(m :double);
    procedure normal(m :double);
    procedure minus(m :double);
    function mtobh2(m: double): double;
    procedure ellipse(bh2, dx, one: double; c : integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

var
  yc, xc    : integer;    // SW
  sc : double = 30;        // XP[


procedure TForm1.clear;
var
  rect: Trect;
begin
  Rect.Top  := 0;
  Rect.Left := 0;
  Rect.Right  := Image1.Width;
  Rect.Bottom := Image1.Height;
  Image1.canvas.Brush.Style := bsSolid;
  Image1.canvas.Brush.Color := clBtnface;
  Image1.canvas.FillRect(Rect);
end;

procedure TForm1.Linetod(x, y: double);
var
  xi, yi: integer;
begin
  xi := round(x * sc + xc);
  yi := round(yc - y * sc);
  Image1.canvas.Lineto(xi, yi);
end;

procedure TForm1.Movetod(x, y: double);
var
  xi, yi: integer;
begin
  xi := round(x * sc + xc);
  yi := round(yc - y * sc);
  Image1.canvas.Moveto(xi, yi);
end;

// q pxdeg  r a
procedure TForm1.anglline(q, r: double);
var
  x, y  : integer;
begin
  x := round(cos(q) * r * sc);
  y := round(sin(q) * r * sc);
  Image1.canvas.Moveto(xc - x, yc - y);
  Image1.canvas.lineto(xc + x, yc + y);
end;

// p[^m  m = k^2  b^2̒lvZ  k S
// m = (a^2 - b^2) / a^2
// m = 1- b^2           a = 1 Ƃ
// b^2 = 1- m
// m > 1 ̎ B^2 < 0  ƂȂ x^2 / a^2 - y^2 / b^2 = 1   ƂȂ܂
// m = 1 ̎  y = 0 x Ő
// 0 < m  < 1 ̎@ȉ~
// m = 0 ~
// m < 0 ̎@cȉ~
function TForm1.mtobh2(m: double): double;
var
  bh: double;                      // b^2
begin
  bh := 1 - m;                     // x^2 / a^2 - y^2 / bh = 1      a = 1
  result := bh;
  if bh >= 0 then begin
    bh := sqrt(bh);
    Image1.Canvas.TextOut(10, Image1.Height - 17, ' a = 1, ' + 'b = ' + floatTostr(bh));
  end
  else begin
    bh := sqrt(-bh);
    Image1.Canvas.TextOut(10, Image1.Height - 17, ' a = 1, ' + 'b = ' + floatTostr(bh) + 'i');
  end;
end;

// m = 1 ̎ }
// y^2 = 0 +  0 * x^2
// y = 0 * x             
procedure TForm1.mnoe;
begin
  sc := 10;

  image1.Canvas.Pen.Color := clred;
  Image1.Canvas.Pen.Style := psDashDot;
  movetod(0, 5);
  lineTod(0, -5);

  image1.Canvas.Pen.Color := clblack;
  Image1.Canvas.Pen.Style := psSolid;
  movetod(-15, 0);
  lineTod(15, 0);

  Image1.Canvas.TextOut(10, Image1.Height - 17, ' a = 1, ' + 'b = 0');
end;

// ȉ~ oȐ }
// bh2   b^2
// dx    x
// one   x̍ŏl 0 or 1
// c     
procedure TForm1.ellipse(bh2, dx, one: double; c : integer);
var
  i : integer;
  x, yh2, y: double;
begin
  x := one;
  yh2 := bh2 - bh2 * x * x;
  y := sqrt(yh2);
  movetod(x, y);
  for i:= 1 to c do begin
    x := i * dx + one;
    yh2 := bh2 - bh2 * x * x;
    y := sqrt(yh2);
    linetod(x, y);
  end;
  x := one;
  yh2 := bh2 - bh2 * x * x;
  y := sqrt(yh2);
  movetod(x, -y);
  for i:= 1 to c do begin
    x := i * dx + one;
    yh2 := bh2 - bh2 * x * x;
    y := sqrt(yh2);
    linetod(x, -y);
  end;
  x := one;
  yh2 := bh2 - bh2 * x * x;
  y := sqrt(yh2);
  movetod(-x, y);
  for i:= 1 to c do begin
    x := i * dx + one;
    yh2 := bh2 - bh2 * x * x;
    y := sqrt(yh2);
    linetod(-x, y);
  end;
  x := one;
  yh2 := bh2 - bh2 * x * x;
  y := sqrt(yh2);
  movetod(-x, -y);
  for i:= 1 to c do begin
    x := i * dx + one;
    yh2 := bh2 - bh2 * x * x;
    y := sqrt(yh2);
    linetod(-x, -y);
  end;
end;

// m > 1
// x^2 / a^2 + y^2 / b^2 = 1    ȉ~̌
// y^2 = b^2 - b^2 * x^2        a = 1 Ƃ
// y = y
// x̒l x >= 1  or x <= -1
procedure TForm1.large(m :double);
const
  c = 50;
var
  Q, Qb   : double;
  bh2, k  : double;
  dx      : double;
begin
  Sc := 15;
  k := sqrt(m);
  Qb := arcsin(1 / k);
  Q := pi / 2 - Qb;
  Image1.Canvas.TextOut(10, 0, 'Qߐpx = ' + floatTostr(Q / pi * 180) + '');
  Image1.Canvas.pen.Color := clred;
  anglline(Q, 12);
  anglline(-Q, 12);

  Image1.Canvas.Pen.Color := clblack;
  Image1.Canvas.Pen.Style := psSolid;
  bh2 := mtobh2(m);
  dx := 12 * cos(Q) / c;
  // 
  ellipse(bh2, dx, 1, c);

  // ڑȉ~
//  Image1.Canvas.Pen.Color := clgreen;
//  dx := 1 / c;
//  ellipse(-bh2, dx, 0, c);
end;

// 0 <= m < 1
// m < 1 ׂ͂ēłvZł }㕪Ă܂ (~Ɖȉ~)
// x^2 / a^2 + y^2 / b^2 = 1    ȉ~̌
// y^2 = b^2 - b^2 * x^2        a = 1 Ƃ
// y = y
// x̒l -1 <= x <= 1
procedure TForm1.normal(m :double);
const
  c = 100;
var
  bh2 : double;
  dx  : double;
begin
  sc := 100;
  image1.Canvas.Pen.Color := clred;
  Image1.Canvas.Pen.Style := psDashDot;
  movetod(0, -1.2);
  linetod(0, 1.2);
  movetod(-1.2, 0);
  linetod(1.2, 0);

  Image1.Canvas.Pen.Color := clblack;
  Image1.Canvas.Pen.Style := psSolid;
  bh2 := mtobh2(m);
  dx := 1 / c;
  // ~Aȉ~
  ellipse(bh2, dx, 0, c);
end;

// m < 0
// m < 1 ׂ͂ēłvZł }㕪Ă܂ (cȉ~)
// x^2 / a^2 + y^2 / b^2 = 1    ȉ~̌
// y^2 = b^2 - b^2 * x^2        a = 1 Ƃ
// y = y
// x̒l -1 <= x <= 1
procedure TForm1.minus(m :double);
const
  c = 50;
var
  bh2, yh2: double;
  dx, x, y     : double;
begin
  bh2 := mtobh2(m);
  dx := 1 / c;
  x := 0;
  yh2 := bh2 - bh2 * x * x;
  y := sqrt(yh2);
  sc := 100;
  Image1.Canvas.Pen.Color := clred;
  Image1.Canvas.Pen.Style := psDashDot;
  movetod(0, -1.2);
  linetod(0, 1.2);
  movetod(-1.2, 0);
  linetod(1.2, 0);
  if 1 <= y then sc := 100 / y;

  Image1.Canvas.Pen.Color := clblack;
  Image1.Canvas.Pen.Style := psSolid;
  // cȉ~
  ellipse(bh2, dx, 0, c);
end;

// l͂Ƒȉ~vZ
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  m, k     : double;
  ch, l : integer;
  kstr, kss: string;
  c : char;
  FI : boolean;
begin
  m := 0;
  if radiobutton1.Checked = true then begin
    val(labelededit1.Text, m, ch);
    if ch <> 0 then begin
      application.MessageBox('͒lɌ肪܂B','',0);
      exit;
    end;
  end;
  FI := False;
  if radiobutton2.Checked = true then begin
    kstr := LabeledEdit2.Text;
    l       := length(kstr);                     // ̒擾
    c       := kstr[l];                          // i̕mF
    if (c = 'i') or (c = 'I') then begin         // iw肾
      kss   := copy(kstr, 1, l - 1);             // ȋO܂ŃRs[
      FI := True;                                // tOZbg
    end
    else Kss := kstr;
    val(kss, k, ch);
    if ch <> 0 then begin
      application.MessageBox('k(S)̒lɊԈႢ܂B','k(S)',0);
      exit;
    end;
    m := k * K;
    if FI then m := -m;                          // km -> -m
  end;
  clear;                                         // ʏ
  if m < 0 then begin
    k := sqrt(-m);
    kstr := 'k = ' + floatTostr(k) + 'i';
  end
  else begin
    k := sqrt(m);
    kstr := 'k = ' + floatTostr(k);
  end;
  Image1.Canvas.TextOut(10,15, kstr);
  if m > 1 then large(m);
  if m = 1 then  mnoe;
  if (0 <= m) and (m < 1) then normal(m);
  if m < 0 then minus(m);
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Top := 10;
  Image1.Left := 10;
  Image1.height := clientheight - 20;
  Image1.Width :=  clientwidth - 150;
  xc := Image1.Width div 2;           // SWX
  yc := Image1.Height div 2;          // SWY
  image1.Canvas.Font.Size := 11;
  Image1.Canvas.Pen.Width := 1;
  clear;
  normal(0.64);
end;

end.
